; bootcode.asm
; dmarrage de la rdaction : 6 octobre 2005
; version 2008-05-19

BITS 16

%include "bootcode.inc" ; dfinition des adresses de base
%include "codesize.inc" ; dfinition de '_fin_dernier_bloc' (AUTO_GENERATED)

; dtecte si la taille est trop grande.
; dans l'absolu, le BIOS peut charger 64K d'un coup (maximum)
; mais attention quand mme aux limites du mode rel
%if _fin_dernier_bloc >  65534
 %error programme trop grand !!!!!
%endif

NB_SECTEURS equ (( _fin_dernier_bloc + 511 ) >> 9 )

;----- Ici c'est la partie excute en 0:7C00 -----
ORG 0

 xor ax,ax ; ajuste les segments de donnes
 mov ds,ax
 mov es,ax

; Pile : utilise TOUT le dernier segment (@ 90000-> A0000-1)
 mov ax,DOS_STACK_SEG
 mov ss,ax
 mov sp,DOS_STACK_TOP

 mov al, dl ; Sauve le no du disque sur lequel on boote
 mov ah, 0; pour la lecture : head = 0 = side one
 mov gs, ax

; memcpy des 512 octets du bootcode en 0:600 (60:0)
 mov di,NEW_BASE
 mov si,OLD_BASE
 cld
 mov cx,512
 repnz
 movsb

; c'est parti !
 jmp 0:NEW_BASE+offset_new


offset_new equ $
;-----------------------------------------
; et l, comme par magie, on est en 0:600h+offset_new
;-----------------------------------------
 sti
 push word _hang+NEW_BASE ; permet de retourner sur "_hang" aprs un jump sur "_display"


;; conversion hex pour le priph de boot :
;
; mov ax,gs
; shr al,4
; cmp al,10
; jb no_h1
; add al,'A'-'9'+1
;no_h1: add al,'0'
; mov bx, 7
; mov ah, 0Eh
; int 10h
;
; mov ax,gs
; and al,0Fh
; cmp al,10
; jb no_h2
; add al,'A'-'9'+1
;no_h2: add al,'0'
; mov bx, 7
; mov ah, 0Eh
; int 10h
;
; mov al,0Dh
; mov bx, 7
; mov ah, 0Eh
; int 10h
;
; mov al,0Ah
; mov bx, 7
; mov ah, 0Eh
; int 10h


;--------------------------------------
; maintenant on essaie de charger les secteurs suivants
 mov ax, (NEW_START>>4) ; normalement, c'est align correctement
 mov es, ax ; valeur utile aussi pour faire le test de signature juste aprs

load_retry:
; lecture des blocs suivants vers es:bx
 mov ax,gs ; head 0, drive (cf plus haut)
 mov dx,ax
 mov ax,NB_SECTEURS+0200h ; NB_SECTEURS = 128max dans al (soit 64K)
 ; le risque est de surcrire les instructions qu'on excute par le contenu du bootblock
 ; qu'on (semble-t-il) recharge de 0. Mais comme il n'y a pas (plus) de SMC, c'est ok.
 xor bx,bx ; ?
 mov cx,2  ; ?
 int 0x13
 jnc short check_sig

; message d'erreur du chargement
 mov si, arghl+NEW_BASE
 call _display

; reset du contrleur
 xor ax,ax
 int 0x13

 dec byte [retry_count+NEW_BASE]
 jnz short load_retry
 ret ; jmp _hang

;--------------------------------------
; les blocs ont t chargs, on vrifie la signature.
check_sig:
 mov si, wrong_signature+NEW_BASE ; prcharge l'adresse du message
; ES: est encore = au dbut des 64K du bloc secondaire
; donc OK pour accder  la signature, mme si taille est max.
 cmp word [es:_fin_dernier_bloc], END_MAGIC
 jnz _display ; return sur hang (faut suivre ! :-))


;---------------------------------------
; Saute dans l'"application"

 xor ax, ax
 mov es, ax
 jmp 0:NEW_START


;;;;;;;;;;;;;;; variables initialises et constantes ;;;;;;;;;;;;;;;

; messages :
arghl: db 'Boot KO',13,10,0
retry_count db 5 ; dcompteur pour les checs de lecteur disquette
wrong_signature: db 'Wrong block signature',13,10,0
freeze: db 13, 10, 'MACHINE FROZEN',7, 0


;
; quelques fonctions utilises par le bootloader et exportes dans l'application :
;

;------------------hang-------------------
_hang: sti
 mov si, freeze+NEW_BASE
__endless2: call _display
__endless: hlt
 jmp short __endless

;---------------_display------------------
; ds:si = src ASCIIZ
_display: lodsb
 cmp al, 0
 jnz short no_ret
 ret
no_ret:
 push si
 mov bx, 7
 mov ah, 0Eh
 int 10h
 pop si
 jmp short _display

;------------------getkey (BIOS)------------------
_getkey: mov ah, 0
 int 016h
 ret

;-----------_display_number_routine------------
; fin de la chaine ASCII dans DS:SI
; nombre  convertir en hexadcimal : eax
_display_number_routine:  mov bl,al
   and bl,0Fh
   cmp bl,9
   jbe short no_add
     add bl,'A'-('9'+1)
no_add:
   add bl,'0'
   mov [si],bl
   dec si
   shr eax,4
 jnz short _display_number_routine
 ret

; QSP 512 octets :
times 510-($-$$) db 0

;
; Signature
;

__bootblock_end: dw 0AA55h ; signature d'un bootblock
