; vesa.inc for nasm
; 16 mai 2008 : VBE3

;
; structure of the block returned by the VESA BIOS
;

%assign VbeInfoBlock        0 ; base  changer au besoin !

%assign VbeSignature        VbeInfoBlock   ; db 'VBE2' : VBE Signature, for extended informations
%assign VbeVersion          VbeInfoBlock+4 ; dw 0300h : VBE Version
%assign OemStringPtr        VbeInfoBlock+6   ;dd Pointer to OEM String
%assign Capabilities        VbeInfoBlock+10  ;dd Capabilities of graphics cont.
;   D0 = DAC is switchable
;      0 = DAC is fixed width, with 6-bits per primary color
;      1 = DAC width is switchable
;   D1 = 1=VGA compatible
;   D2 = RAMDAC operation
;      0 = normal
;      1 = "When programming large blocks of information to the RAMDAC,
;            use the blank bit in function 09h"
%assign VideoModePtr        VbeInfoBlock+14  ;dd Pointer to Video Mode List
%assign TotalMemory         VbeInfoBlock+18  ;dw Number of 64kb memory blocks
%assign OemSoftwareRev      VbeInfoBlock+20  ;dw VBE implementation Software revision
%assign OemVendorNamePtr    VbeInfoBlock+22  ;dd Pointer to Vendor Name String
%assign OemProductNamePtr   VbeInfoBlock+26  ;dd Pointer to Product Name String
%assign OemProductRevPtr    VbeInfoBlock+30  ;dd Pointer to Product Revision String
%assign Reserved            VbeInfoBlock+34  ;times 222 db 0 ; Reserved for scratch
%assign OemData             VbeInfoBlock+256 ;times 256 db 0 ; Data Area for OEM Strings

;
; Info block for a specified video mode:
;

%assign ModeInfoBlock        VbeInfoBlock+512
%assign ModeAttributes       ModeInfoBlock     ; dw mode attributes
; D0 = Mode supported in hardware
;   0 = Mode not supported in hardware
;   1 = Mode supported in hardware
; D1 = 1 (Reserved)
; D2 = Output functions supported by BIOS
;   0 = Output functions not supported by BIOS
;   1 = Output functions supported by BIOS
; D3 = Monochrome/color mode (see note below)
;   0 = Monochrome mode
;   1 = Color mode
; D4 = Mode type
;   0 = Text mode
;   1 = Graphics mode
; etc.

%assign WinAAttributes       ModeInfoBlock+2   ; db window A attributes
%assign WinBAttributes       ModeInfoBlock+3   ; db window B attributes
%assign WinGranularity       ModeInfoBlock+4   ; dw window granularity
%assign WinSize              ModeInfoBlock+6   ; dw window size
%assign WinASegment          ModeInfoBlock+8   ; dw window A start segment
%assign WinBSegment          ModeInfoBlock+10  ; dw window B start segment
%assign WinFuncPtr           ModeInfoBlock+12  ; dd pointer to window function
%assign BytesPerScanLine     ModeInfoBlock+16  ; dw bytes per scan line
%assign XResolution          ModeInfoBlock+18  ; dw horizontal resolution
%assign YResolution          ModeInfoBlock+20  ; dw vertical resolution
%assign XCharSize            ModeInfoBlock+22  ; db character cell width
%assign YCharSize            ModeInfoBlock+23  ; db character cell height
%assign NumberOfPlanes       ModeInfoBlock+24  ; db number of memory planes
%assign BitsPerPixel         ModeInfoBlock+25  ; db bits per pixel
%assign NumberOfBanks        ModeInfoBlock+26  ; db number of banks
%assign MemoryModel          ModeInfoBlock+27  ; db memory model type
; 00h =     Text mode
; 01h =     CGA graphics
; 02h =     Hercules graphics
; 03h =     4-plane planar
; 04h =     Packed pixel
; 05h =     Non-chain 4, 256 color
; 06h =     Direct Color
; 07h =     YUV
; 08h-0Fh = Reserved, to be defined by VESA
; 10h-FFh = To be defined by OEM

%assign BankSize             ModeInfoBlock+28  ; db bank size in KB
%assign NumberOfImagePages   ModeInfoBlock+29  ; db number of images
%assign Reserved_2           ModeInfoBlock+30  ; db reserved for page function
%assign RedMaskSize          ModeInfoBlock+31  ; db size of direct color red mask
%assign RedFieldPosition     ModeInfoBlock+32  ; db bit position of lsb of red mask
%assign GreenMaskSize        ModeInfoBlock+33  ; db size of direct color green mask
%assign GreenFieldPosition   ModeInfoBlock+34  ; db bit position of lsb of green mask
%assign BlueMaskSize         ModeInfoBlock+35  ; db size of direct color blue mask
%assign BlueFieldPosition    ModeInfoBlock+36  ; db bit position of lsb of blue mask
%assign RsvdMaskSize         ModeInfoBlock+37  ; db size of direct color reserved mask
%assign RsvdFieldPosition    ModeInfoBlock+38  ; db bit position of lsb of reserved mask
%assign DirectColorModeInfo  ModeInfoBlock+39  ; db direct color mode attributes
%assign PhysBasePtr          ModeInfoBlock+40  ; dd physical address for flat frame buffer
%assign OffScreenMemOffset   ModeInfoBlock+44  ; dd pointer to start of off screen memory ===> 0 (VBE3)
%assign OffScreenMemSize     ModeInfoBlock+48  ; dw amount of off screen memory in 1k units ===> 0 (VBE3)

; VBE3 :
%assign LinBytesPerScanLine  ModeInfoBlock+50  ; dw
%assign BnkNrOfImagePages    ModeInfoBlock+52  ; db
%assign LinNrOfImagePages    ModeInfoBlock+53  ; db
%assign LinRedMaskSize       ModeInfoBlock+54  ; db
%assign LinRedFieldPos       ModeInfoBlock+55  ; db
%assign LinGreenMaskSize     ModeInfoBlock+56  ; db
%assign LinGreenFieldPos     ModeInfoBlock+57  ; db
%assign LinBlueMaskSize      ModeInfoBlock+58  ; db
%assign LinBlueFieldPosn     ModeInfoBlock+59  ; db
%assign LinRsvdMaskSize      ModeInfoBlock+60  ; db
%assign LinRsvdFieldPos      ModeInfoBlock+61  ; db
%assign MaxPixelClock        ModeInfoBlock+62  ; dd Maximum pixel clock in Hz

%assign Reserved_3           ModeInfoBlock+66  ; db 189 dup (?) remainder

