; Le "programme"

%include "bootcode.inc" ; adresses de base
%include "symbols.inc" ; adresse de _hang, _display, ....
%include "vesa.inc" ; dfinition des adresses et valeurs pour grer la vido

BITS 16
ORG NEW_START ; attention  ne pas s'embrouiller dans les offsets !!!!
; CS=ES=DS=0
; IP=0x800
; SP=FFF8h ( peu prs), SS=9000h (tout le segment)

;; variables : (rcrit le dbut du bootcode)
%assign videomode       NEW_BASE+0 ; dd
%assign videomode_index NEW_BASE+2   ; dd

;------------------
; VBE 2 LFB setup :
;------------------

 push ss
 pop es ; es=9000h, plein de place dispo, tant qu'on n'empile pas FFFFh-1024 octets

; crit les signatures
 mov ax, 0300h
 mov [es:VbeVersion],ax
 mov eax, 'VBE2'
 mov [es:VbeSignature],eax

; 1- detection
 mov ax,4F00h ; Function 0 : return SuperVGA information
 mov di,VbeInfoBlock ; ES:
 int 10h
 mov si,no_VESA ; DS: (prpare l'adresse du message)
 cmp ax,byte 004Fh ; vrifie la premire signature
 jne _display
 cmp dword [es:VbeSignature],'VESA' ; check the signature
 jne _display

; charge le pointeur de dbut de liste dans GS:DI
 lgs di,[ss:VideoModePtr]
; puis sauve DI pour plus tard
 mov [videomode_index], di
loop_videomodes:

; copie le mode vido courant dans videomode pour plus tard
 mov ax,[gs:di]
 mov [videomode],ax
; fin de la liste indique par FFFFh
 cmp ax,0FFFFh
 jnz suite_mode_OK
  mov si,FinListe
  jmp __endless2
suite_mode_OK:

; infos supplmentaires sur le mode :
 mov ax,4F01h ; Function 1 : Return SuperVGA mode information
 mov cx,[videomode]  ; Mode number
 mov di,ModeInfoBlock ; ES:DI = Pointer to ModeInfoBlock structure
 int 10h ; this is important because we get the linear framebuffer address
 mov si,no_VESA ; DS:
 cmp ax,byte 004Fh
 jne _display


; affiche les infos de la carte :
 call Display_mode
 call _getkey
 call LF
 call LF
 mov di,[videomode_index]
 add di,2
 mov [videomode_index],di
 jmp loop_videomodes


;;;;;;;;;;;;;;; fonctions...

LF:       mov si,LineFeed
display2: push cs
          pop ds
          jmp _display

Display_mode:

 lds si,[es:OemStringPtr] 
 call _display
 call LF

 lds si,[es:OemVendorNamePtr] 
 call _display
 call LF

 lds si,[es:OemProductNamePtr] 
 call _display
 call LF

 lds si,[es:OemProductRevPtr] 
 call _display
 call LF

 movzx eax,word [cs:videomode]
 mov  si,modestringhex
 call _display_number_routine
 mov si,modestring
 call display2

 movzx eax,word [es:TotalMemory]
 mov  si,totalMemHex
 call _display_number_routine
 mov si,totalMem
 call display2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 test byte[es:Capabilities],000000001b
 jz no_CapD0
  mov si,CapD0
  call _display
no_CapD0:


 test byte[es:Capabilities],000000010b
 jz no_CapD1
  mov si,CapD1
  call _display
no_CapD1:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 test byte[es:ModeAttributes],000000001b
 jz no_attrD0
  mov si,attrD0
  call _display
no_attrD0:

 test byte[es:ModeAttributes],000000100b
 jz no_attrD2
  mov si,attrD2
  call _display
no_attrD2:

 test byte[es:ModeAttributes],000001000b
 jz no_attrD3
  mov si,attrD3
  call _display
no_attrD3:

 test byte[es:ModeAttributes],00010000b
 jz no_attrD4
  mov si,attrD4
  call _display
no_attrD4:

 test byte[es:ModeAttributes],00100000b
 jnz no_attrD5
  mov si,attrD5
  call _display
no_attrD5:

 test byte[es:ModeAttributes],10000000b
 jz no_attrD7
  mov si,attrD7
  call _display
no_attrD7:

; VBE3 :

 test byte[es:ModeAttributes+1],00000001b
 jz no_attrD8
  mov si,attrD8
  call _display
no_attrD8:

 test byte[es:ModeAttributes+1],00000010b
 jz no_attrD9
  mov si,attrD9
  call _display
no_attrD9:

 test byte[es:ModeAttributes+1],00000100b
 jz no_attrD10
  mov si,attrD10
  call _display
no_attrD10:

 test byte[es:ModeAttributes+1],00001000b
 jz no_attrD11
  mov si,attrD11
  call _display
no_attrD11:

 test byte[es:ModeAttributes+1],00010000b
 jz no_attrD12
  mov si,attrD12
  call _display
no_attrD12:


 ; rsolution X:
 mov eax,'0000'
 mov dword[attrXhex-3],eax
 movzx eax,word [es:XResolution]
 mov  si,attrXhex
 call _display_number_routine
 mov si,attrX
 call display2
 
 ; rsolution Y:
 mov eax,'0000'
 mov dword[attrYhex-3],eax
 movzx eax,word [es:YResolution]
 mov  si,attrYhex
 call _display_number_routine
 mov si,attrY
 call display2
 
 ; rsolution couleurs:
 mov eax,'0000'
 mov dword[attrBPPhex-3],eax
 movzx eax,byte[es:BitsPerPixel]
 mov  si,attrBPPhex
 call _display_number_routine
 mov si,attrBPP
 call display2

 ; mode graphique :
 movzx bx,[es:MemoryModel]
 mov si,vesamodeUnknown
 test bl, 11111000b
 jnz suite_mode
 shl bx,1
 mov si,[bx+vesamodetable]
suite_mode:
 jmp display2
; call display2
; ret

;;;;;;;;;;;;;;;;;; constantes
no_VESA:        db 'VBE3 not supported'
LineFeed:       db 13,10,0
modestring:     db 'mode 0000000'
modestringhex:  db '0h',13,10,0
totalMem        db '00000'
totalMemHex     db '00000h bytes VRAM',13,10,0
CapD0:          db 'DAC is switchable to 8-bit',13,10,0
CapD1:          db 'Controller is VGA compatible',13,10,0
attrD0:         db 'D0=mode is available',13,10,0
attrD2:         db 'D2=text output supported by BIOS',13,10,0
attrD3:         db 'D3=Color mode',13,10,0
attrD4:         db 'D4=Graphics mode',13,10,0
attrD5:         db 'D5=VGA compatible mode',13,10,0
attrD7:         db 'D7=LFB mode available',13,10,0
; VBE3:
attrD8:         db 'D8=DoubleScan mode available',13,10,0
attrD9:         db 'D9=Interlaced mode available',13,10,0
attrD10:        db 'D10=HW triple buffering available',13,10,0
attrD11:        db 'D11=HW stereoscopic support',13,10,0
attrD12:        db 'D12=Dual display start address support',13,10,0

attrX:          db 'resolution X: 0000'
attrXhex:       db '0h pixels',13,10,0
attrY:          db 'resolution Y: 0000'
attrYhex:       db '0h pixels',13,10,0
attrBPP:        db 'couleurs: 000'
attrBPPhex:     db '0h bpp',13,10
vesamode_string: db "Type : ",0
vesamode0:      db "Text mode",13,10,0
vesamode1:      db "CGA graphics",13,10,0
vesamode2:      db "Hercules graphics",13,10,0
vesamode3:      db "4-plane planar",13,10,0
vesamode4:      db "Packed pixel",13,10,0
vesamode5:      db "Non-chain 4, 256 color",13,10,0
vesamode6:      db "Direct Color",13,10,0
vesamode7:      db "YUV",13,10,0
vesamodeUnknown: db "inconnu",13,10,0
vesamodetable: dw vesamode0, vesamode1, vesamode2, vesamode3, vesamode4, vesamode5, vesamode6, vesamode7

FinListe: db "Fin de la liste",13,10,0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Signature pour la fin (ne pas toucher ni utiliser autre part !!!)
_fin_dernier_bloc: dw END_MAGIC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
